cdac.medinfo.sdk.hl7282.baselibs

## Class CCD

- java.lang.Object
- - cdac.medinfo.sdk.hl7282.baselibs.CompositeDataType
  - - cdac.medinfo.sdk.hl7282.baselibs.CCD

- All Implemented Interfaces:
    IDataType

      public class CCD
      extends CompositeDataType

  CCD - Charge Code and Date

  This data type Specifies whether a charge action is based on an invocation event or is time-based.

  Represents an HL7 CCD data type. This data type has the following attributes:

  1. when to charge code (ID)Required
  2. date/time (DTM)Optional

  This class provides accessors & mutators for the elements mentioned above. This class override the equal method, to check whether some other object is "equal to" this one.

  User can also create Data Type through `DataElementFactory`

- - ### Constructor Summary

    Constructors
    Constructor and Description
    `CCD()` Default Constructor for CCD
    `CCD(int iComponentType, IDataTypeMap objIDataTypeMap)` Constructor for CCD class which takes two arguments and sets the value in the respective member variable.
    `CCD(int iComponentType, int iMinLength, int iMaxLength, java.lang.String strCLength, IDataTypeMap objIDataTypeMap)` Constructor for CCD class which takes five arguments and sets the value in the respective member variable.
    `CCD(int iComponentType, int iMinLength, int iMaxLength, java.lang.String strCLength, int ITableNo, IDataTypeMap objIDataTypeMap)` Constructor for CCD class which takes six arguments and sets the value in the respective member variable.
    `CCD(int iMinLength, int iMaxLength, java.lang.String strCLength, int iComponentType)` Constructor for CCD class which takes four arguments and sets the value in the respective member variable.
    `CCD(int iMinLength, int iMaxLength, java.lang.String strCLength, int iTableNo, int iComponentType)` Constructor for CCD class which takes five arguments and sets the value in the respective member variable.

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `boolean` | `equals(java.lang.Object objObject)` This method checks the equality of Object.
    `DTM` | `getDatetime()` Returns Date/time
    `ID` | `getInvocationEvent()` Returns Invocation Event
    `void` | `setDateTime(DTM objDTM)` Sets the Time.
    `void` | `setDateTime(java.lang.String strDateTime)` Sets the Time.
    `void` | `setInvocationEvent(ID objID)` Sets the Invocation Event.
    `void` | `setInvocationEvent(java.lang.String strInvocationEvent)` Sets the Invocation Event.
    `boolean` | `validate()` The Method validates the Input value,and if validated properly then returns true.

    - ### Methods inherited from class cdac.medinfo.sdk.hl7282.baselibs.CompositeDataType

      `copy, dumpDataType, getAttributes, getDataTypeName, getLength, getValue, isPrimitive, read, setValue, write, writeToXML`

    - ### Methods inherited from class java.lang.Object

      `getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### CCD

          public CCD()

      Default Constructor for CCD

    - #### CCD

          public CCD(int iMinLength,
             int iMaxLength,
             java.lang.String strCLength,
             int iComponentType)
              throws InvalidComponentTypeException

      Constructor for CCD class which takes four arguments and sets the value in the respective member variable.
      Parameters:
        `iMinLength` - The Minimum length the DataType can have.
        `iMaxLength` - The Maximum length the DataType can have.
        `iCLength` - The Conformance length the DataType can have.
        `iComponentType` - The Type of the component i.e Component or a subcomponent.
      Throws:
        `InvalidComponentTypeException` - - if Component Type is not specified or valid.

    - #### CCD

          public CCD(int iMinLength,
             int iMaxLength,
             java.lang.String strCLength,
             int iTableNo,
             int iComponentType)
              throws InvalidComponentTypeException

      Constructor for CCD class which takes five arguments and sets the value in the respective member variable.
      Parameters:
        `iMinLength` - The Minimum length the DataType can have.
        `iMaxLength` - The Maximum length the DataType can have.
        `iCLength` - The Conformance length the DataType can have.
        `iTableNo` - The Table number to which the value for the component is specified.
        `iComponentType` - The Type of the component i.e Component or a subcomponent.
      Throws:
        `InvalidComponentTypeException` - - if Component Type is not specified or valid.

    - #### CCD

          public CCD(int iComponentType,
             IDataTypeMap objIDataTypeMap)

      Constructor for CCD class which takes two arguments and sets the value in the respective member variable.
      Parameters:
        `objIDataTypeMap` - object of Data Type Map.
        `iComponentType` - The Type of the component i.e Component or a subcomponent.
      Throws:
        `InvalidComponentTypeException` - - if Component Type is not specified or valid.

    - #### CCD

          public CCD(int iComponentType,
             int iMinLength,
             int iMaxLength,
             java.lang.String strCLength,
             IDataTypeMap objIDataTypeMap)

      Constructor for CCD class which takes five arguments and sets the value in the respective member variable.
      Parameters:
        `objIDataTypeMap` - object of Data Type Map.
        `iComponentType` - The Type of the component i.e Component or a subcomponent.
        `iMinLength` - The Minimum length the DataType can have.
        `iMaxLength` - The Maximum length the DataType can have.
        `iCLength` - The Conformance length the DataType can have.
      Throws:
        `InvalidComponentTypeException` - - if Component Type is not specified or valid.

    - #### CCD

          public CCD(int iComponentType,
             int iMinLength,
             int iMaxLength,
             java.lang.String strCLength,
             int ITableNo,
             IDataTypeMap objIDataTypeMap)

      Constructor for CCD class which takes six arguments and sets the value in the respective member variable.
      Parameters:
        `objIDataTypeMap` - object of Data Type Map.
        `iComponentType` - The Type of the component i.e Component or a subcomponent.
        `iMinLength` - The Minimum length the DataType can have.
        `iMaxLength` - The Maximum length the DataType can have.
        `iCLength` - The Conformance length the DataType can have.
        `iTableNo` - The Table number to which the value for the component is specified.
      Throws:
        `InvalidComponentTypeException` - - if Component Type is not specified or valid.

  - ### Method Detail

    - #### setInvocationEvent

          public void setInvocationEvent(java.lang.String strInvocationEvent)

      Sets the Invocation Event.
      Parameters:
        `strInvocationEvent` - Specifies the code for the event precipitating/triggering the charge activity. [Refer to HL7 Table 0100 - Invocation event] valid values -D,O,R,S,T.

    - #### setInvocationEvent

          public void setInvocationEvent(ID objID)

      Sets the Invocation Event.
      Parameters:
        `objID` - Specifies the code for the event precipitating/triggering the charge activity. [Refer to HL7 Table 0100 - Invocation event] valid values -D,O,R,S,T.

    - #### setDateTime

          public void setDateTime(java.lang.String strDateTime)

      Sets the Time.
      Parameters:
        `strTime` - Specifies a point in time using a 24-hour clock notation.

    - #### setDateTime

          public void setDateTime(DTM objDTM)
                           throws InvalidDataTypeException

      Sets the Time.
      Parameters:
        `objDTM` - Specifies a point in time using a 24-hour clock notation.
      Throws:
        `InvalidDataTypeException`

    - #### getInvocationEvent

          public ID getInvocationEvent()

      Returns Invocation Event
      Returns:
        ID - data type.

    - #### getDatetime

          public DTM getDatetime()

      Returns Date/time
      Returns:
        TS - data type.

    - #### validate

          public boolean validate()
                           throws InvalidDataTypeException

      The Method validates the Input value,and if validated properly then returns true. Here the validation is based on the compulsory fields for the DataType.
      Specified by:
        `validate` in interface `IDataType`
      Overrides:
        `validate` in class `CompositeDataType`
      Returns:
        boolean - true or false.
      Throws:
        `InvalidDataTypeException` - - if Invalid values is entered or Mandatory field is missing.

    - #### equals

          public boolean equals(java.lang.Object objObject)

      This method checks the equality of Object.
      Overrides:
        `equals` in class `java.lang.Object`
      Parameters:
        `objObject` - object of Object class.
      Returns:
        boolean - shows success or failure of the comparison.